Index: TOOLS/WATER_BUDGET/nemo.py
===================================================================
--- TOOLS/WATER_BUDGET/nemo.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/nemo.py	(revision 6647)
@@ -738,73 +858,76 @@
     See NEMO documentation for further details
     '''
-
     jpj, jpi, nperio = lbc_init (ptab, nperio)
+    ix, ax = __findAxis__ (ptab, 'x')
+    jy, ay = __findAxis__ (ptab, 'y')
     psgn   = ptab.dtype.type (psgn)
     ztab   = ptab.copy ()
-    #
-    #> East-West boundary conditions
-    # ------------------------------
-    if nperio in [1, 4, 6] :
-        # ... cyclic
-        ztab [..., :,  0] = ztab [..., :, -2]
-        ztab [..., :, -1] = ztab [..., :,  1]
-
-    #> Masks south
-    # ------------
-    if nperio in [4, 6] : ztab [..., 0, : ] = sval
-        
-    #
-    #> North-South boundary conditions
-    # --------------------------------
-    if nperio in [3, 4] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1,  :      ] = sval
-            #ztab [..., -2, jpi//2: ] = sval
-            ztab [..., -2, :jpi//2 ] = sval # Give better plots than above
-        if cd_type == 'U' :
-            ztab [..., -1, : ] = sval
-
-        if cd_type == 'V' : 
-            ztab [..., -2, : ] = sval
-            ztab [..., -1, : ] = sval
-            
-        if cd_type == 'F' :
-            ztab [..., -2, : ] = sval
-            ztab [..., -1, : ] = sval
-
-    if nperio in [4.2] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1, jpi//2:  ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1, jpi//2-1:-1] = sval
-                
-        if cd_type == 'V' : 
-            ztab [..., -1, 1:       ] = sval
-                
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1     ] = sval
-      
-    if nperio in [5, 6] :            #  North fold F-point pivot  
-        if cd_type in ['T', 'W']  :
-            ztab [..., -1, : ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1, : ] = sval      
-             
-        if cd_type == 'V' :
-            ztab [..., -1, :        ] = sval
-            ztab [..., -2, jpi//2:  ] = sval
-                             
-        if cd_type == 'F' :
-            ztab [..., -1, :          ] = sval
-            ztab [..., -2, jpi//2+1:-1] = sval
+
+    if ax : 
+        #
+        #> East-West boundary conditions
+        # ------------------------------
+        if nperio in [1, 4, 6] :
+            # ... cyclic
+            ztab [..., :,  0] = ztab [..., :, -2]
+            ztab [..., :, -1] = ztab [..., :,  1]
+
+        if ay : 
+            #> Masks south
+            # ------------
+            if nperio in [4, 6] : ztab [..., 0, : ] = sval
+
+            #
+            #> North-South boundary conditions
+            # --------------------------------
+            if nperio in [3, 4] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1,  :      ] = sval
+                    #ztab [..., -2, jpi//2: ] = sval
+                    ztab [..., -2, :jpi//2 ] = sval # Give better plots than above
+                if cd_type == 'U' :
+                    ztab [..., -1, : ] = sval
+
+                if cd_type == 'V' : 
+                    ztab [..., -2, : ] = sval
+                    ztab [..., -1, : ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -2, : ] = sval
+                    ztab [..., -1, : ] = sval
+
+            if nperio in [4.2] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1, jpi//2:  ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1, jpi//2-1:-1] = sval
+
+                if cd_type == 'V' : 
+                    ztab [..., -1, 1:       ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1     ] = sval
+
+            if nperio in [5, 6] :            #  North fold F-point pivot  
+                if cd_type in ['T', 'W']  :
+                    ztab [..., -1, : ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1, : ] = sval      
+
+                if cd_type == 'V' :
+                    ztab [..., -1, :        ] = sval
+                    ztab [..., -2, jpi//2:  ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -1, :          ] = sval
+                    ztab [..., -2, jpi//2+1:-1] = sval
 
     return ztab
 
-#@numba.jit(forceobj=True)
 def lbc_add (ptab, nperio=None, cd_type=None, psgn=1, sval=None) :
     '''
-    Handle NEMO domain changes between NEMO 4.0 to NEMO 4.2
+    Handles NEMO domain changes between NEMO 4.0 to NEMO 4.2
       Peridodicity halo has been removed
     This routine adds the halos if needed
@@ -818,4 +941,7 @@
     mmath = __mmath__ (ptab) 
     jpj, jpi, nperio = lbc_init (ptab, nperio)
+    lshape = get_shape (ptab)
+    ix, ax = __findAxis__ (ptab, 'x')
+    jy, ay = __findAxis__ (ptab, 'y')
 
     t_shape = np.array (ptab.shape)
@@ -823,22 +949,31 @@
     if nperio == 4.2 or nperio == 6.2 :
       
-        ext_shape = t_shape
-        ext_shape[-1] = ext_shape[-1] + 2
-        ext_shape[-2] = ext_shape[-2] + 1
+        ext_shape = t_shape.copy()
+        if 'X' in lshape : ext_shape[ix] = ext_shape[ix] + 2
+        if 'Y' in lshape : ext_shape[jy] = ext_shape[jy] + 1
 
         if mmath == xr :
-            ptab_ext = xr.DataArray (np.zeros (ext_shape), dims=ptab.dims) 
-            ptab_ext.values[..., :-1, 1:-1] = ptab.values.copy ()
+            ptab_ext = xr.DataArray (np.zeros (ext_shape), dims=ptab.dims)
+            if 'X' in lshape and 'Y' in lshape :
+                ptab_ext.values[..., :-1, 1:-1] = ptab.values.copy ()
+            else :
+                if 'X' in lshape     : ptab_ext.values[...,      1:-1] = ptab.values.copy ()
+                if 'Y' in lshape     : ptab_ext.values[..., :-1      ] = ptab.values.copy ()
         else           :
             ptab_ext =               np.zeros (ext_shape)
-            ptab_ext[..., :-1, 1:-1] = ptab.copy ()
-            
-        #if sval != None :  ptab_ext[..., 0, :] = sval
-        
+            if 'X' in lshape and 'Y' in lshape : ptab_ext       [..., :-1, 1:-1] = ptab.copy ()
+            else :
+                if 'X' in lshape     : ptab_ext       [...,      1:-1] = ptab.copy ()
+                if 'Y' in lshape     : ptab_ext       [..., :-1      ] = ptab.copy ()            
+
         if nperio == 4.2 : ptab_ext = lbc (ptab_ext, nperio=4, cd_type=cd_type, psgn=psgn)
         if nperio == 6.2 : ptab_ext = lbc (ptab_ext, nperio=6, cd_type=cd_type, psgn=psgn)
-             
+        
         if mmath == xr :
             ptab_ext.attrs = ptab.attrs
+            kz, az = __findAxis__ (ptab, 'z')
+            it, at = __findAxis__ (ptab, 't')
+            if az : ptab_ext = ptab_ext.assign_coords ( {az:ptab.coords[az]} )
+            if at : ptab_ext = ptab_ext.assign_coords ( {at:ptab.coords[at]} )
 
     else : ptab_ext = lbc (ptab, nperio=nperio, cd_type=cd_type, psgn=psgn)
@@ -848,5 +983,5 @@
 def lbc_del (ptab, nperio=None, cd_type='T', psgn=1) :
     '''
-    Handle NEMO domain changes between NEMO 4.0 to NEMO 4.2
+    Handles NEMO domain changes between NEMO 4.0 to NEMO 4.2
       Periodicity halo has been removed
     This routine removes the halos if needed
@@ -858,13 +993,23 @@
     See NEMO documentation for further details
     '''
-
     jpj, jpi, nperio = lbc_init (ptab, nperio)
+    lshape = get_shape (ptab)
+    ix, ax = __findAxis__ (ptab, 'x')
+    jy, ay = __findAxis__ (ptab, 'y')
 
     if nperio == 4.2 or nperio == 6.2 :
-        return lbc (ptab[..., :-1, 1:-1], nperio=nperio, cd_type=cd_type, psgn=psgn)
+        if ax or ay : 
+            if ax and ay : 
+                return lbc (ptab[..., :-1, 1:-1], nperio=nperio, cd_type=cd_type, psgn=psgn)
+            else : 
+                if ax :
+                    return lbc (ptab[...,      1:-1], nperio=nperio, cd_type=cd_type, psgn=psgn)
+                if ay :
+                    return lbc (ptab[..., -1], nperio=nperio, cd_type=cd_type, psgn=psgn)
+        else :
+            return ptab
     else :
         return ptab
 
-#@numba.jit(forceobj=True)
 def lbc_index (jj, ii, jpj, jpi, nperio=None, cd_type='T') :
     '''
@@ -951,5 +1096,61 @@
     return jy, ix
     
-#def geo2en (pxx, pyy, pzz, glam, gphi) : 
+def findJI (lat_data, lon_data, lat_grid, lon_grid, mask=1.0, verbose=False, out=None) :
+    '''
+    Description: seeks J,I indices of the grid point which is the closest of a given point 
+    Usage: go FindJI  <data latitude> <data longitude> <grid latitudes> <grid longitudes> [mask]
+    <longitude fields> <latitude field> are 2D fields on J/I (Y/X) dimensions
+    mask : if given, seek only non masked grid points (i.e with mask=1)
+    
+    Example : findIJ (40, -20, nav_lat, nav_lon, mask=1.0)
+
+    Note : all longitudes and latitudes in degrees
+        
+    Note : may work with 1D lon/lat (?)
+    '''
+    # Get grid dimensions
+    if len (lon_grid.shape) == 2 : (jpj, jpi) = lon_grid.shape
+    else                         : jpj = len(lat_grid) ; jpi=len(lon_grid)
+
+    mmath = __mmath__ (lat_grid)
+        
+    # Compute distance from the point to all grid points (in radian)
+    arg      = np.sin (rad*lat_data) * np.sin (rad*lat_grid) \
+             + np.cos (rad*lat_data) * np.cos (rad*lat_grid) * np.cos(rad*(lon_data-lon_grid))
+    distance = np.arccos (arg) + 4.0*rpi*(1.0-mask) # Send masked points to 'infinite' 
+
+    # Truncates to alleviate some precision problem with some grids
+    prec = int (1E7)
+    distance = (distance*prec).astype(int) / prec
+
+    # Compute minimum of distance, and index of minimum
+    #
+    distance_min = distance.min    ()
+    jimin        = int (distance.argmin ())
+    
+    # Compute 2D indices 
+    jmin = jimin // jpi ; imin = jimin - jmin*jpi
+    
+    # Result
+    if verbose :
+        # Compute distance achieved
+        mindist = distance [jmin, imin]
+        
+        # Compute azimuth
+        dlon = lon_data-lon_grid[jmin,imin]
+        arg  = np.sin (rad*dlon) /  (np.cos(rad*lat_data)*np.tan(rad*lat_grid[jmin,imin]) - np.sin(rad*lat_data)*np.cos(rad*dlon))
+        azimuth = dar*np.arctan (arg)
+        print ( f'I={imin:d} J={jmin:d} - Data:{lat_data:5.1f}Â°N {lon_data:5.1f}Â°E - Grid:{lat_grid[jmin,imin]:4.1f}Â°N '   \
+            +   f'{lon_grid[jmin,imin]:4.1f}Â°E - Dist: {ra*distance[jmin,imin]:6.1f}km {dar*distance[jmin,imin]:5.2f}Â° ' \
+            +   f'- Azimuth: {rad*azimuth:3.2f}rad - {azimuth:5.1f}Â°' )
+
+    if   out=='dict'                               : return {'x':imin, 'y':jmin}
+    elif out=='array' or out=='numpy'  or out=='np': return np.array ( [jmin, imin] )
+    elif out=='xarray' or out=='xr'                : return xr.DataArray ( [jmin, imin] )
+    elif out=='list'                               : return [jmin, imin]
+    elif out=='tuple'                              : return jmin, imin
+    else                                           : return jmin, imin
+
+def geo2en (pxx, pyy, pzz, glam, gphi) : 
     '''
     Change vector from geocentric to east/north
@@ -970,5 +1171,5 @@
     return pte, ptn
 
-#def en2geo (pte, ptn, glam, gphi) :
+def en2geo (pte, ptn, glam, gphi) :
     '''
     Change vector from east/north to geocentric
@@ -990,68 +1191,200 @@
     return pxx, pyy, pzz
 
-#def findJI (lat_data, lon_data, lat_grid, lon_grid, mask=1.0, verbose=False) :
-    '''
-    Description: seeks J,I indices of the grid point which is the closest of a given point 
-    Usage: go FindJI  <data latitude> <data longitude> <grid latitudes> <grid longitudes> [mask]
-    <longitude fields> <latitude field> are 2D fields on J/I (Y/X) dimensions
-    mask : if given, seek only non masked grid points (i.e with mask=1)
-    
-    Example : findIJ (40, -20, nav_lat, nav_lon, mask=1.0)
-
-    Note : all longitudes and latitudes in degrees
-        
-    Note : may work with 1D lon/lat (?)
-    '''
-    # Get grid dimensions
-    if len (lon_grid.shape) == 2 : (jpj, jpi) = lon_grid.shape
-    else                         : jpj = len(lat_grid) ; jpi=len(lon_grid)
-
-    mmath = __mmath__ (lat_grid)
-        
-    # Compute distance from the point to all grid points (in radian)
-    arg      = np.sin (rad*lat_data) * np.sin (rad*lat_grid) \
-             + np.cos (rad*lat_data) * np.cos (rad*lat_grid) * np.cos(rad*(lon_data-lon_grid))
-    distance = np.arccos (arg) + 4.0*rpi*(1.0-mask) # Send masked points to 'infinite' 
-
-    # Truncates to alleviate some precision problem with some grids
-    prec = int (1E7)
-    distance = (distance*prec).astype(int) / prec
-
-    # Compute minimum of distance, and index of minimum
-    #
-    distance_min = distance.min    ()
-    jimin        = int (distance.argmin ())
-    
-    # Compute 2D indices 
-    jmin = jimin // jpi ; imin = jimin - jmin*jpi
-
-    # Compute distance achieved
-    mindist = distance[jmin, imin]
-    
-    # Compute azimuth
-    dlon = lon_data-lon_grid[jmin,imin]
-    arg  = np.sin (rad*dlon) /  (np.cos(rad*lat_data)*np.tan(rad*lat_grid[jmin,imin]) - np.sin(rad*lat_data)*np.cos(rad*dlon))
-    azimuth = dar*np.arctan (arg)
-    
-    # Result
-    if verbose : 
-        print ('I={:d} J={:d} - Data:{:5.1f}Â°N {:5.1f}Â°E - Grid:{:4.1f}Â°N {:4.1f}Â°E - Dist: {:6.1f}km {:5.2f}Â° - Azimuth: {:3.2f}rad - {:5.1f}Â°'
-            .format (imin, jmin, lat_data, lon_data, lat_grid[jmin,imin], lon_grid[jmin,imin], ra*distance[jmin,imin], dar*distance[jmin,imin], rad*azimuth, azimuth))
-
-    return jmin, imin
-
-#def clo_lon (lon, lon0) :
+
+def clo_lon (lon, lon0=0., rad=False, deg=True) :
     '''Choose closest to lon0 longitude, adding or substacting 360Â° if needed'''
     mmath = __mmath__ (lon, np)
-        
+    if rad : lon_range = 2.*np.pi
+    if deg : lon_range = 360.
     clo_lon = lon
-    clo_lon = mmath.where (clo_lon > lon0 + 180., clo_lon-360., clo_lon)
-    clo_lon = mmath.where (clo_lon < lon0 - 180., clo_lon+360., clo_lon)
-    clo_lon = mmath.where (clo_lon > lon0 + 180., clo_lon-360., clo_lon)
-    clo_lon = mmath.where (clo_lon < lon0 - 180., clo_lon+360., clo_lon)
+    clo_lon = mmath.where (clo_lon > lon0 + lon_range*0.5, clo_lon-lon_range, clo_lon)
+    clo_lon = mmath.where (clo_lon < lon0 - lon_range*0.5, clo_lon+lon_range, clo_lon)
+    clo_lon = mmath.where (clo_lon > lon0 + lon_range*0.5, clo_lon-lon_range, clo_lon)
+    clo_lon = mmath.where (clo_lon < lon0 - lon_range*0.5, clo_lon+lon_range, clo_lon)
     if clo_lon.shape == () : clo_lon = clo_lon.item ()
+    if mmath == xr :
+        try : 
+            for attr in lon.attrs : clo_lon.attrs[attr] = lon.attrs[attr]
+        except :
+            pass
     return clo_lon
 
-#def angle_full (glamt, gphit, glamu, gphiu, glamv, gphiv, glamf, gphif, nperio=None) :
+
+def index2depth (pk, gdept_0) :
+    '''
+    From index (real, continuous), get depth
+    '''
+    jpk = gdept_0.shape[0]
+    kk = xr.DataArray(pk)
+    k  = np.maximum (0, np.minimum (jpk-1, kk    ))
+    k0 = np.floor (k).astype (int)
+    k1 = np.maximum (0, np.minimum (jpk-1,  k0+1))
+    zz = k - k0
+    gz = (1.0-zz)*gdept_0[k0]+ zz*gdept_0[k1]
+    return gz.values
+
+def depth2index (pz, gdept_0) :
+    '''
+    From depth, get index (real, continuous)
+    '''
+    jpk  = gdept_0.shape[0]
+    if type (pz) == xr.core.dataarray.DataArray :
+        zz   = xr.DataArray (pz.values, dims=('zz',))
+    elif type (pz) == np.ndarray :
+        zz   = xr.DataArray (pz.ravel(), dims=('zz',))
+    else :
+        zz   = xr.DataArray (np.array([pz]).ravel(), dims=('zz',))
+    zz   = np.minimum (gdept_0[-1], np.maximum (0, zz))
+    
+    idk1 = np.minimum ( (gdept_0-zz), 0.).argmax (axis=0).astype(int)
+    idk1 = np.maximum (0, np.minimum (jpk-1,  idk1  ))
+    idk2 = np.maximum (0, np.minimum (jpk-1,  idk1-1))
+    
+    ff = (zz - gdept_0[idk2])/(gdept_0[idk1]-gdept_0[idk2])
+    idk = ff*idk1 + (1.0-ff)*idk2
+    idk = xr.where ( np.isnan(idk), idk1, idk)
+    return idk.values
+
+def index2depth_panels (pk, gdept_0, depth0, fact) :
+    '''
+    From  index (real, continuous), get depth, with bottom part compressed
+    '''
+    jpk = gdept_0.shape[0]
+    kk = xr.DataArray (pk)
+    k  = np.maximum (0, np.minimum (jpk-1, kk    ))
+    k0 = np.floor (k).astype (int)
+    k1 = np.maximum (0, np.minimum (jpk-1,  k0+1))
+    zz = k - k0
+    gz = (1.0-zz)*gdept_0[k0]+ zz*gdept_0[k1]
+    gz = xr.where ( gz<depth0, gz, depth0 + (gz-depth0)*fact)
+    return gz.values
+
+def depth2index_panels (pz, gdept_0, depth0, fact) :
+    '''
+    From  index (real, continuous), get depth, with bottom part compressed
+    '''
+    jpk = gdept_0.shape[0]
+    if type (pz) == xr.core.dataarray.DataArray :
+        zz   = xr.DataArray (pz.values , dims=('zz',))
+    elif type (pz) == np.ndarray :
+        zz   = xr.DataArray (pz.ravel(), dims=('zz',))
+    else : 
+        zz   = xr.DataArray (np.array([pz]).ravel(), dims=('zz',))
+    zz         = np.minimum (gdept_0[-1], np.maximum (0, zz))
+    gdept_comp = xr.where ( gdept_0>depth0, (gdept_0-depth0)*fact+depth0, gdept_0)
+    zz_comp    = xr.where ( zz     >depth0, (zz     -depth0)*fact+depth0, zz     )
+    zz_comp    = np.minimum (gdept_comp[-1], np.maximum (0, zz_comp))
+
+    idk1 = np.minimum ( (gdept_0-zz_comp), 0.).argmax (axis=0).astype(int)
+    idk1 = np.maximum (0, np.minimum (jpk-1,  idk1  ))
+    idk2 = np.maximum (0, np.minimum (jpk-1,  idk1-1))
+     
+    ff = (zz_comp - gdept_0[idk2])/(gdept_0[idk1]-gdept_0[idk2])
+    idk = ff*idk1 + (1.0-ff)*idk2
+    idk = xr.where ( np.isnan(idk), idk1, idk)
+    return idk.values
+
+def depth2comp (pz, depth0, fact ) :
+    '''
+    Form depth, get compressed depth, with bottom part compressed
+    '''
+    #print ('start depth2comp')
+    if type (pz) == xr.core.dataarray.DataArray :
+        zz   = pz.values
+    elif type(pz) == list :
+        zz = np.array (pz)
+    else : 
+        zz   = pz
+    gz = np.where ( zz>depth0, (zz-depth0)*fact+depth0, zz)
+    #print ( f'depth2comp : {gz=}' )
+    if type (pz) in [int, float] : return gz.item()
+    else : return gz
+    #print ('end depth2comp')
+
+def comp2depth (pz, depth0, fact ) :
+    '''
+    Form compressed depth, get depth, with bottom part compressed
+    '''
+    if type (pz) == xr.core.dataarray.DataArray :
+        zz   = pz.values
+    elif type(pz) == list :
+        zz = np.array (pz)
+    else : 
+        zz   = pz
+    gz = np.where ( zz>depth0, (zz-depth0)/fact+depth0, zz)
+    if type (pz) in [int, float] : return gz.item()
+    else : return gz
+
+def index2lon (pi, lon1D) :
+    '''
+    From index (real, continuous), get longitude
+    '''
+    jpi = lon1D.shape[0]
+    ii = xr.DataArray (pi)
+    i =  np.maximum (0, np.minimum (jpi-1, ii    ))
+    i0 = np.floor (i).astype (int)
+    i1 = np.maximum (0, np.minimum (jpi-1,  i0+1))
+    xx = i - i0
+    gx = (1.0-xx)*lon1D[i0]+ xx*lon1D[i1]
+    return gx.values
+
+def lon2index (px, lon1D) :
+    '''
+    From longitude, get index (real, continuous)
+    '''
+    jpi  = lon1D.shape[0]
+    if type (px) == xr.core.dataarray.DataArray :
+        xx   = xr.DataArray (px.values , dims=('xx',))
+    elif type (px) == np.ndarray :
+        xx   = xr.DataArray (px.ravel(), dims=('xx',))
+    else : 
+        xx   = xr.DataArray (np.array([px]).ravel(), dims=('xx',))
+    xx   = xr.where ( xx>lon1D.max(), xx-360.0, xx)
+    xx   = xr.where ( xx<lon1D.min(), xx+360.0, xx)
+    xx   = np.minimum (lon1D.max(), np.maximum(xx, lon1D.min() ))
+    idi1 = np.minimum ( (lon1D-xx), 0.).argmax (axis=0).astype(int)
+    idi1 = np.maximum (0, np.minimum (jpi-1,  idi1  ))
+    idi2 = np.maximum (0, np.minimum (jpi-1,  idi1-1))
+    
+    ff = (xx - lon1D[idi2])/(lon1D[idi1]-lon1D[idi2])
+    idi = ff*idi1 + (1.0-ff)*idi2
+    idi = xr.where ( np.isnan(idi), idi1, idi)
+    return idi.values
+
+def index2lat (pj, lat1D) :
+    '''
+    From index (real, continuous), get latitude
+    '''
+    jpj = lat1D.shape[0]
+    jj  = xr.DataArray (pj)
+    j   = np.maximum (0, np.minimum (jpj-1, jj    ))
+    j0  = np.floor (j).astype (int)
+    j1  = np.maximum (0, np.minimum (jpj-1,  j0+1))
+    yy  = j - j0
+    gy  = (1.0-yy)*lat1D[j0]+ yy*lat1D[j1]
+    return gy.values
+
+def lat2index (py, lat1D) :
+    '''
+    From latitude, get index (real, continuous)
+    '''
+    jpj = lat1D.shape[0]
+    if type (py) == xr.core.dataarray.DataArray :
+        yy   = xr.DataArray (py.values , dims=('yy',))
+    elif type (py) == np.ndarray :
+        yy   = xr.DataArray (py.ravel(), dims=('yy',))
+    else : 
+        yy   = xr.DataArray (np.array([py]).ravel(), dims=('yy',))
+    yy   = np.minimum (lat1D.max(), np.minimum(yy, lat1D.max() ))
+    idj1 = np.minimum ( (lat1D-yy), 0.).argmax (axis=0).astype(int)
+    idj1 = np.maximum (0, np.minimum (jpj-1,  idj1  ))
+    idj2 = np.maximum (0, np.minimum (jpj-1,  idj1-1))
+    
+    ff = (yy - lat1D[idj2])/(lat1D[idj1]-lat1D[idj2])
+    idj = ff*idj1 + (1.0-ff)*idj2
+    idj = xr.where ( np.isnan(idj), idj1, idj)
+    return idj.values
+
+def angle_full (glamt, gphit, glamu, gphiu, glamv, gphiv, glamf, gphif, nperio=None) :
     '''Compute sinus and cosinus of model line direction with respect to east'''
     mmath = __mmath__ (glamt)
@@ -1234,10 +1567,10 @@
     v_n = + u_i * gsin + v_j * gcos
     
-    u_e = lbc (u_e, nperio=nperio, cd_type=cd_type, psgn= 1.0)
-    v_n = lbc (v_n, nperio=nperio, cd_type=cd_type, psgn= 1.0)
+    u_e = lbc (u_e, nperio=nperio, cd_type=cd_type, psgn=1.0)
+    v_n = lbc (v_n, nperio=nperio, cd_type=cd_type, psgn=1.0)
     
     return u_e, v_n
 
-def rot_uv2en ( uo, vo, gsint, gcost, nperio, zdim='deptht' ) :
+def rot_uv2en ( uo, vo, gsint, gcost, nperio, zdim=None ) :
     '''
     ** Purpose :   Rotate the Repere: Change vector componantes from
@@ -1247,5 +1580,5 @@
     '''
     mmath = __mmath__ (uo)
-
+    
     ut = U2T (uo, nperio=nperio, psgn=-1.0, zdim=zdim)
     vt = V2T (vo, nperio=nperio, psgn=-1.0, zdim=zdim)
@@ -1259,5 +1592,5 @@
     return u_e, v_n
 
-def rot_uv2enF ( uo, vo, gsinf, gcosf, nperio, zdim='deptht' ) :
+def rot_uv2enF ( uo, vo, gsinf, gcosf, nperio, zdim=None ) :
     '''
     ** Purpose : Rotate the Repere: Change vector componantes from
@@ -1279,6 +1612,5 @@
     return u_e, v_n
 
-#@numba.jit(forceobj=True)
-def U2T (utab, nperio=None, psgn=-1.0, zdim='deptht', action='ave') :
+def U2T (utab, nperio=None, psgn=-1.0, zdim=None, action='ave') :
     '''Interpolate an array from U grid to T grid i-mean)'''
     mmath = __mmath__ (utab)
@@ -1287,20 +1619,23 @@
     utab_0 = lbc_add (utab_0, nperio=nperio, cd_type='U', psgn=psgn)
     ix, ax = __findAxis__ (utab_0, 'x')
-    iz, az = __findAxis__ (utab_0, 'z')
-    if action == 'ave'  : ttab = 0.5 *      (utab_0 + np.roll (utab_0, axis=ix, shift=1))
-    if action == 'min'  : ttab = np.minimum (utab_0 , np.roll (utab_0, axis=ix, shift=1))
-    if action == 'max'  : ttab = np.maximum (utab_0 , np.roll (utab_0, axis=ix, shift=1))
-    if action == 'mult' : ttab =             utab_0 * np.roll (utab_0, axis=ix, shift=1)
-    ttab = lbc_del (ttab, nperio=nperio, cd_type='T', psgn=psgn)
-    
+    kz, az = __findAxis__ (utab_0, 'z')
+
+    if ax : 
+        if action == 'ave' : ttab = 0.5 *      (utab_0 + np.roll (utab_0, axis=ix, shift=1))
+        if action == 'min' : ttab = np.minimum (utab_0 , np.roll (utab_0, axis=ix, shift=1))
+        if action == 'max' : ttab = np.maximum (utab_0 , np.roll (utab_0, axis=ix, shift=1))
+        if action == 'mult': ttab =             utab_0 * np.roll (utab_0, axis=ix, shift=1)
+        ttab = lbc_del (ttab  , nperio=nperio, cd_type='T', psgn=psgn)
+    else : 
+        ttab = lbc_del (utab_0, nperio=nperio, cd_type='T', psgn=psgn)
+        
     if mmath == xr :
-        if ax != None :
+        if ax :
             ttab = ttab.assign_coords({ax:np.arange (ttab.shape[ix])+1.})
-        if zdim != None and iz != None  and az != 'olevel' : 
-            ttab = ttab.rename( {az:zdim}) 
+        if zdim and az :
+            if az != zdim : ttab = ttab.rename( {az:zdim}) 
     return ttab
 
-#@numba.jit(forceobj=True)
-def V2T (vtab, nperio=None, psgn=-1.0, zdim='deptht', action='ave') :
+def V2T (vtab, nperio=None, psgn=-1.0, zdim=None, action='ave') :
     '''Interpolate an array from V grid to T grid (j-mean)'''
     mmath = __mmath__ (vtab)
@@ -1308,29 +1643,31 @@
     vtab_0 = mmath.where ( np.isnan(vtab), 0., vtab)
     vtab_0 = lbc_add (vtab_0, nperio=nperio, cd_type='V', psgn=psgn)
-    iy, ay = __findAxis__ (vtab_0, 'y')
-    iz, az = __findAxis__ (vtab_0, 'z')
-    if action == 'ave'  : ttab = 0.5 *      (vtab_0 + np.roll (vtab_0, axis=iy, shift=1))
-    if action == 'min'  : ttab = np.minimum (vtab_0 , np.roll (vtab_0, axis=iy, shift=1))
-    if action == 'max'  : ttab = np.maximum (vtab_0 , np.roll (vtab_0, axis=iy, shift=1))
-    if action == 'mult' : ttab =             vtab_0 * np.roll (vtab_0, axis=iy, shift=1)
-    ttab = lbc_del (ttab, nperio=nperio, cd_type='T', psgn=psgn)
+    jy, ay = __findAxis__ (vtab_0, 'y')
+    kz, az = __findAxis__ (vtab_0, 'z')
+    if ay : 
+        if action == 'ave'  : ttab = 0.5 *      (vtab_0 + np.roll (vtab_0, axis=jy, shift=1))
+        if action == 'min'  : ttab = np.minimum (vtab_0 , np.roll (vtab_0, axis=jy, shift=1))
+        if action == 'max'  : ttab = np.maximum (vtab_0 , np.roll (vtab_0, axis=jy, shift=1))
+        if action == 'mult' : ttab =             vtab_0 * np.roll (vtab_0, axis=jy, shift=1)
+        ttab = lbc_del (ttab  , nperio=nperio, cd_type='T', psgn=psgn)
+    else :
+        ttab = lbc_del (vtab_0, nperio=nperio, cd_type='T', psgn=psgn)
+        
     if mmath == xr :
-        if ay !=None : 
-            ttab = ttab.assign_coords({ay:np.arange(ttab.shape[iy])+1.})
-        if zdim != None and iz != None  and az != 'olevel' :
-            ttab = ttab.rename( {az:zdim}) 
+        if ay :
+            ttab = ttab.assign_coords({ay:np.arange(ttab.shape[jy])+1.})
+        if zdim and az :
+            if az != zdim : ttab = ttab.rename( {az:zdim}) 
     return ttab
 
-#@numba.jit(forceobj=True)
-def F2T (ftab, nperio=None, psgn=1.0, zdim='depthf', action='ave') :
+def F2T (ftab, nperio=None, psgn=1.0, zdim=None, action='ave') :
     '''Interpolate an array from F grid to T grid (i- and j- means)'''
     mmath = __mmath__ (ftab)
     ftab_0 = mmath.where ( np.isnan(ftab), 0., ftab)
     ftab_0 = lbc_add (ftab_0 , nperio=nperio, cd_type='F', psgn=psgn)
-    ttab = V2T(F2V(ftab_0, nperio=nperio, psgn=psgn, zdim=zdim, action=action), nperio=nperio, psgn=psgn, zdim=zdim, action=action)
+    ttab = V2T (F2V (ftab_0, nperio=nperio, psgn=psgn, zdim=zdim, action=action), nperio=nperio, psgn=psgn, zdim=zdim, action=action)
     return lbc_del (ttab, nperio=nperio, cd_type='T', psgn=psgn)
 
-#@numba.jit(forceobj=True)
-def T2U (ttab, nperio=None, psgn=1.0, zdim='depthu', action='ave') :
+def T2U (ttab, nperio=None, psgn=1.0, zdim=None, action='ave') :
     '''Interpolate an array from T grid to U grid (i-mean)'''
     mmath = __mmath__ (ttab)
@@ -1338,41 +1675,45 @@
     ttab_0 = lbc_add (ttab_0 , nperio=nperio, cd_type='T', psgn=psgn)
     ix, ax = __findAxis__ (ttab_0, 'x')
-    iz, az = __findAxis__ (ttab_0, 'z')
-    if action == 'ave'  : utab = 0.5 *      (ttab_0 + np.roll (ttab_0, axis=ix, shift=-1))
-    if action == 'min'  : utab = np.minimum (ttab_0 , np.roll (ttab_0, axis=ix, shift=-1))
-    if action == 'max'  : utab = np.maximum (ttab_0 , np.roll (ttab_0, axis=ix, shift=-1))
-    if action == 'mult' : utab =             ttab_0 * np.roll (ttab_0, axis=ix, shift=-1)
-    utab = lbc_del (utab, nperio=nperio, cd_type='U', psgn=psgn)
-
+    kz, az = __findAxis__ (ttab_0, 'z')
+    if ix : 
+        if action == 'ave'  : utab = 0.5 *      (ttab_0 + np.roll (ttab_0, axis=ix, shift=-1))
+        if action == 'min'  : utab = np.minimum (ttab_0 , np.roll (ttab_0, axis=ix, shift=-1))
+        if action == 'max'  : utab = np.maximum (ttab_0 , np.roll (ttab_0, axis=ix, shift=-1))
+        if action == 'mult' : utab =             ttab_0 * np.roll (ttab_0, axis=ix, shift=-1)
+        utab = lbc_del (utab  , nperio=nperio, cd_type='U', psgn=psgn)
+    else :
+        utab = lbc_del (ttab_0, nperio=nperio, cd_type='U', psgn=psgn)
+        
     if mmath == xr :    
-        if ax != None : 
+        if ax : 
             utab = ttab.assign_coords({ax:np.arange(utab.shape[ix])+1.})
-        if zdim != None  and iz != None  and az != 'olevel' :
-            utab = utab.rename( {az:zdim}) 
+        if zdim and az :
+            if az != zdim : utab = utab.rename( {az:zdim}) 
     return utab
 
-#@numba.jit(forceobj=True)
-def T2V (ttab, nperio=None, psgn=1.0, zdim='depthv', action='ave') :
+def T2V (ttab, nperio=None, psgn=1.0, zdim=None, action='ave') :
     '''Interpolate an array from T grid to V grid (j-mean)'''
     mmath = __mmath__ (ttab)
     ttab_0 = mmath.where ( np.isnan(ttab), 0., ttab)
     ttab_0 = lbc_add (ttab_0 , nperio=nperio, cd_type='T', psgn=psgn)
-    iy, ay = __findAxis__ (ttab_0, 'y')
-    iz, az = __findAxis__ (ttab_0, 'z')
-    if action == 'ave'  : vtab = 0.5 *      (ttab_0 + np.roll (ttab_0, axis=iy, shift=-1))
-    if action == 'min'  : vtab = np.minimum (ttab_0 , np.roll (ttab_0, axis=iy, shift=-1))
-    if action == 'max'  : vtab = np.maximum (ttab_0 , np.roll (ttab_0, axis=iy, shift=-1))
-    if action == 'mult' : vtab =             ttab_0 * np.roll (ttab_0, axis=iy, shift=-1)
-
-    vtab = lbc_del (vtab, nperio=nperio, cd_type='V', psgn=psgn)
+    jy, ay = __findAxis__ (ttab_0, 'y')
+    kz, az = __findAxis__ (ttab_0, 'z')
+    if jy : 
+        if action == 'ave'  : vtab = 0.5 *      (ttab_0 + np.roll (ttab_0, axis=jy, shift=-1))
+        if action == 'min'  : vtab = np.minimum (ttab_0 , np.roll (ttab_0, axis=jy, shift=-1))
+        if action == 'max'  : vtab = np.maximum (ttab_0 , np.roll (ttab_0, axis=jy, shift=-1))
+        if action == 'mult' : vtab =             ttab_0 * np.roll (ttab_0, axis=jy, shift=-1)
+        vtab = lbc_del (vtab  , nperio=nperio, cd_type='V', psgn=psgn)
+    else :
+        vtab = lbc_del (ttab_0, nperio=nperio, cd_type='V', psgn=psgn)
+
     if mmath == xr :
-        if ay != None : 
-            vtab = vtab.assign_coords({ay:np.arange(vtab.shape[iy])+1.})
-        if zdim != None  and iz != None and az != 'olevel' :
-            vtab = vtab.rename( {az:zdim}) 
+        if ay : 
+            vtab = vtab.assign_coords({ay:np.arange(vtab.shape[jy])+1.})
+        if zdim and az :
+            if az != zdim : vtab = vtab.rename( {az:zdim}) 
     return vtab
 
-#@numba.jit(forceobj=True)
-def V2F (vtab, nperio=None, psgn=-1.0, zdim='depthf', action='ave') :
+def V2F (vtab, nperio=None, psgn=-1.0, zdim=None, action='ave') :
     '''Interpolate an array from V grid to F grid (i-mean)'''
     mmath = __mmath__ (vtab)
